<?php  global $bic_fs; ?>
<div class="wrap">
	<h1><?php _e( 'Blocked in China', 'blocked-in-china' ); ?></h1>

	<nav class="nav-tab-wrapper">
		<a href="?page=blocked-in-china" class="nav-tab nav-tab-active"><?php _e( 'Status', 'blocked-in-china' ); ?></a>
		<a href="?page=blocked-in-china&tab=schedule" class="nav-tab"><?php _e( 'Schedule', 'blocked-in-china' ); ?></a>
		<a href="?page=blocked-in-china&tab=log" class="nav-tab"><?php _e( 'Log', 'blocked-in-china' ); ?></a>
		<a href="?page=blocked-in-china&tab=bundle" class="nav-tab"><?php _e( 'China Plugins Bundle <span class="dashicons dashicons-star-filled bic-yellow"></span>', 'blocked-in-china' ); ?></a>
	</nav>

	<?php 

	$frequency = 'monthly';
	$freemius_plan = 'free';

	
	if ( $bic_fs->is_plan( 'personal', true ) ) {
		$freemius_plan = 'personal';
		$frequency = bic_get_preemius_levels('personal');
	} else if ( $bic_fs->is_plan( 'pro', true ) ) {
		$freemius_plan = 'pro';
		$frequency = bic_get_preemius_levels('pro');
	} else if ( $bic_fs->is_plan( 'agency', true ) ) {
		$freemius_plan = 'agency';
		$frequency = bic_get_preemius_levels('agency');
	}

	$bic_manual_api_run = get_option( 'bic_manual_api_run' );
	$remaining_gap = 0;
	if($bic_manual_api_run){

		$timestamp = $bic_manual_api_run;
		$date2 = gmdate( 'Y-m-d H:i:s', $timestamp );
		$date1 =  gmdate( 'Y-m-d H:i:s' );
		$b = new DateTime($date2);
		$a = new DateTime($date1);
		$interval = $b->diff($a);

		$remaining_gap = $interval->y + $interval->m + $interval->d + $interval->h;

	}

	?>

	<?php if( !$remaining_gap ){?>
		<h2 class="title"><?php _e( 'Welcome to Blocked in China', 'blocked-in-china' ); ?></h2>
		<p><?php _e( 'Check the status of your site to determine if it is available in China.', 'blocked-in-china' ); ?></p>
	<?php } ?>

	<form id="gpbic_form" method="POST" novalidate="novalidate">
		<input type="hidden" id="form_action" name="action" value="gpbic_run_api_manual" />	
		<?php wp_nonce_field( 'gpbic_nonce' ); ?>

		<p class="submit">
			<button type="submit" name="submit" id="submit" class="button button-primary" <?php echo $remaining_gap ? 'disabled' : '' ; ?> ><?php _e( 'Check Status', 'blocked-in-china' ); ?></button>
			<span class="spinner"></span>
		</p>
	</form>

	<p>
		<?php 
		printf(
		    __( 'Your %1$s plan entitles you to %2$s Blocked in China Status updates for your site.', 'blocked-in-china' ),
		    '<strong>' . ucfirst($freemius_plan) . '</strong>',
		    '<strong>' . ucfirst($frequency) . '</strong>'
		);
		?>
	</p>
	<p>
		<?php
		if ( $remaining_gap ) {
			
			$remaining_time = [];
			if( $interval->d ){
				/* translators: 1: days count, 2: plural days count. */
				$days = sprintf(
				    _n(
				        '%1$s day',
				        '%1$s days',
				        $interval->d,
				        'blocked-in-china'
				    ),
				    number_format_i18n( $interval->d )
				);

				array_push( $remaining_time, $days );

			}

			if( $interval->h ){
				/* translators: 1: hours count, 2: plural hours count. */
				$hours = sprintf(
				    _n(
				        '%1$s hour',
				        '%1$s hours',
				        $interval->h,
				        'blocked-in-china'
				    ),
				    number_format_i18n( $interval->h )
				);

				array_push( $remaining_time, $hours );

			}

			if( $interval->i ){
				/* translators: 1: minutes count, 2: minutes hours count. */
				$mins = sprintf(
				    _n(
				        '%1$s minute',
				        '%1$s minutes',
				        $interval->i,
				        'blocked-in-china'
				    ),
				    number_format_i18n( $interval->i )
				);

				array_push( $remaining_time, $mins );

			}

			if( $interval->s ){
				/* translators: 1: seconds count, 2: plural seconds count. */
				$seconds = sprintf(
				    _n(
				        '%1$s second',
				        '%1$s seconds',
				        $interval->s,
				        'blocked-in-china'
				    ),
				    number_format_i18n( $interval->s )
				);

				array_push( $remaining_time, $seconds );

			}

		} 

		if( $remaining_gap ){
			$remaining_time_text = " in " . implode( ", ", $remaining_time );
		} else{
			$remaining_time_text = __( 'now', 'blocked-in-china' );
		}

		printf(
		    __( 'Your next status update is available %1$s.', 'blocked-in-china' ),
		    $remaining_time_text
		);
		?>
	</p>
	<p>
		<?php
		printf(
		    __( 'To get more frequent Status Updates, %1$s.', 'blocked-in-china' ),
		    '<a href="' . esc_url( $bic_fs->get_upgrade_url() ) . '">' . __( 'Upgrade here', 'blocked-in-china' ) . ' ></a>'
		);
		?>
	</p>

	<p>
		<?php 
		printf( 
			__( 'Learn more about our plugin in our %1$s or by %2$s.', 'blocked-in-china' ),
			'<a href="'. esc_url( 'https://docs.blockedinchina.io' ) .'" target="_blank">' . __( 'Documentation', 'blocked-in-china' ) . '</a>',
			'<a href="'. esc_url( 'https://blockedinchina.io' ) .'" target="_blank">' . __( 'visiting our site', 'blocked-in-china' ) . '</a>'
		);
		?>

	</p>
	
	<p>
		<label>
				<input id="bic_status_bar" type="checkbox" name="bic_status" <?php echo get_option('bic_admin_bar_status') ? 'checked' : ''; ?>> <?php _e( 'Enable WP Admin bar status', 'blocked-in-china' )?>
		</label>
	</p>

	<?php 
	$bic_manual_api_run_last = get_option( 'bic_manual_api_run_last' );
	$manual_log = get_option( 'bic_cron_log' .'-'. gmdate('Y-m-d H:i', $bic_manual_api_run_last) );
	$class_name = '';

	if(isset($manual_log)){
		$class_name = $manual_log['data']['summary']['result'] == "visible" ? 'notice-success' : 'notice-error' ;
	}
	?>
		<div id="gpbic_form_response" class="bic-notice <?php echo esc_attr($class_name);?>" style="display: <?php echo $remaining_gap ? 'block' : 'none';?>;" >
			<?php 
			if(isset($manual_log)){
				printf(
					'<p>%s</p>',
					$manual_log['data']['summary']['description']
				);
			}
			?>
		</div>

		<table id="gpbic_form_result" class="wp-list-table widefat fixed striped" style="display: <?php echo $remaining_gap ? 'table' : 'none';?>;">
			<thead>
				<tr>
					<th width="30%"><?php _e( 'Location', 'blocked-in-china' ); ?></th>
					<th width="50%"><?php _e( 'Lookup Result', 'blocked-in-china' ); ?></th>
					<th width="20%"><?php _e( 'Status', 'blocked-in-china' ); ?></th>
				</tr>
			</thead>
			<tbody>
				<?php
				if(isset($manual_log['data']['servers'])){
					foreach ($manual_log['data']['servers'] as $server) {
						printf('<tr>');
						printf('<td>%s</td>', esc_html($server['location']));
						printf('<td>%s</td>', esc_html($server['resultvalue']));
						printf('<td>%s</td>', $server['resultstatus'] == 'ok' ? '<span class="dashicons dashicons-yes-alt"></span>' : '<span class="dashicons dashicons-dismiss"></span>');
						printf('</tr>');
					}
				}else{
					printf('<tr><td colspan="3">No result found!</td></tr>');
				}
				
				?>
			</tbody>
		</table>

</div>